#line 1 "C:/Users/Software/Desktop/Breakout ( 2 )/Breakout.c"
#line 1 "c:/users/software/desktop/breakout ( 2 )/breakout_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 20 "c:/users/software/desktop/breakout ( 2 )/breakout_types.h"
typedef struct
{
 uint16_t posX;
 uint8_t posY;

} T_touchpad_touchPoint;
#line 1 "c:/users/software/desktop/breakout ( 2 )/breakout_config.h"
#line 1 "c:/users/software/desktop/breakout ( 2 )/breakout_types.h"
#line 3 "c:/users/software/desktop/breakout ( 2 )/breakout_config.h"
const uint32_t _MATRIXRGB_SPI_CFG[ 2 ] =
{
 _SPI_FPCLK_DIV128,
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_CLK_IDLE_LOW |
 _SPI_MASTER |
 _SPI_MSB_FIRST |
 _SPI_8_BIT |
 _SPI_SSM_ENABLE |
 _SPI_SS_DISABLE |
 _SPI_SSI_1
};

const uint32_t _TOUCHPAD_I2C_CFG[ 1 ] =
{
 100000
};
#line 1 "c:/users/software/desktop/breakout ( 2 )/demo.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 139 "c:/users/software/desktop/breakout ( 2 )/demo.h"
typedef struct
{
 uint16_t x;
 uint16_t y;
 uint16_t color;

} demo_object_t;


typedef struct
{
 uint16_t x;
 uint16_t y;
 uint8_t direction;

} demo_ball_t;


typedef struct
{
 uint8_t x_min;
 uint8_t y_min;
 uint8_t x_max;
 uint8_t y_max;

} demo_bounds_t;



void demo_generateWall( demo_object_t *wall );
void demo_reset( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall );
void demo_moveBall( demo_ball_t *ball );
void demo_movePaddle( demo_object_t *paddle, uint8_t mode );
uint8_t demo_collisionCheck( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall );
#line 8 "C:/Users/Software/Desktop/Breakout ( 2 )/Breakout.c"
demo_object_t wall[  8  * 6  ];
demo_object_t paddle;
demo_ball_t ball;

void getUserInput( )
{

 demo_movePaddle( &paddle,  0  );

}

void systemInit( )
{
 mikrobus_logInit( _LOG_USBUART, 9600 );


 mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );

 mikrobus_spiInit( _MIKROBUS5, &_MATRIXRGB_SPI_CFG[ 0 ] );



 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_PWM_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );


 Delay_ms( 100 );
}

void applicationInit( )
{

 matrixrgb_spiDriverInit( (  const uint8_t*  )&_MIKROBUS5_GPIO,
 (  const uint8_t*  )&_MIKROBUS5_SPI );
 matrixrgb_deviceReset( );

 matrixrgb_deviceInit( _MATRIXRGB_PATTERN_1_MAP_6MM );
 matrixrgb_setPower( 1 );
 Delay_ms( 1000 );

 demo_generateWall( wall );

 ball.x =  0x0010 ;
 ball.y =  0x001C ;

 paddle.x =  0x000D ;
 paddle.y =  0x001F ;

 demo_reset( &ball, &paddle, wall );



 slider2_gpioDriverInit( (  const uint8_t*  )&_MIKROBUS1_GPIO );
 slider2_enable( _SLIDER2_DEVICE_ENABLE );
 slider2_setReference( _SLIDER2_MAX_VOLTAGE_2_048V );

 ADC_Set_Input_Channel( _ADC_CHANNEL_3 );
 ADC1_Init( );

 Delay_100ms( );

}

void applicationTask( )
{
 while( !demo_collisionCheck( &ball, &paddle, wall ) )
 {
 getUserInput( );
 demo_moveBall( &ball );
 }
}

void main( )
{
 systemInit( );
 applicationInit( );

 while ( 1 )
 {
 applicationTask( );
 }
}
