#line 1 "C:/Users/Software/Desktop/Breakout ( 2 )/Demo.c"
#line 1 "c:/users/software/desktop/breakout ( 2 )/demo.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 139 "c:/users/software/desktop/breakout ( 2 )/demo.h"
typedef struct
{
 uint16_t x;
 uint16_t y;
 uint16_t color;

} demo_object_t;


typedef struct
{
 uint16_t x;
 uint16_t y;
 uint8_t direction;

} demo_ball_t;


typedef struct
{
 uint8_t x_min;
 uint8_t y_min;
 uint8_t x_max;
 uint8_t y_max;

} demo_bounds_t;



void demo_generateWall( demo_object_t *wall );
void demo_reset( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall );
void demo_moveBall( demo_ball_t *ball );
void demo_movePaddle( demo_object_t *paddle, uint8_t mode );
uint8_t demo_collisionCheck( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall );
#line 1 "c:/users/software/desktop/breakout ( 2 )/game_over.h"

static uint16_t game_over[  272  ] = {

 5, 8, 6, 8, 7, 8 , 12, 8, 13, 8, 17, 8, 21, 8, 23, 8, 24, 8, 25, 8, 26, 8, 27, 8,
 4, 9, 8, 9, 11, 9, 14, 9, 17, 9, 18, 9, 20, 9, 21, 9, 23, 9,
 4, 10, 10, 10, 15, 10, 17, 10, 19, 10, 21, 10, 23, 10,
 4, 11, 10, 11, 15, 11, 17, 11, 21, 11, 23, 11, 24, 11, 25, 11, 26, 11, 27, 11,
 4, 12, 7, 12, 8, 12, 10, 12, 11, 12, 12, 12, 13, 12, 14, 12, 15, 12, 17, 12, 21, 12, 23, 12,
 4, 13, 8, 13, 10, 13, 15, 13, 17, 13, 21, 13, 23, 13,
 5, 14, 6, 14, 7, 14, 10, 14, 15, 14, 17, 14, 21, 14, 23, 14, 24, 14, 25, 14, 26, 14, 27, 14,
 5, 17, 6, 17, 7, 17, 10, 17, 15, 17, 17, 17, 18, 17, 19, 17, 20, 17, 21, 17, 23, 17, 24, 17, 25, 17, 26, 17,
 4, 18, 8, 18, 10, 18, 15, 18, 17, 18, 23, 18, 27, 18,
 4, 19, 8, 19, 10, 19, 15, 19, 17, 19, 23, 19, 27, 19,
 4, 20, 8, 20, 10, 20, 15, 20, 17, 20, 18, 20, 19, 20, 20, 20, 21, 20, 23, 20, 24, 20, 25, 20, 26, 20,
 4, 21, 8, 21, 10, 21, 15, 21, 17, 21, 23, 21, 25, 21,
 4, 22, 8, 22, 11, 22, 14, 22, 17, 22, 23, 22, 26, 22,
 5, 23, 6, 23, 7, 23, 12, 23, 13, 23, 17, 23, 18, 23, 19, 23, 20, 23, 21, 23, 23, 23, 27, 23
};
#line 7 "C:/Users/Software/Desktop/Breakout ( 2 )/Demo.c"
static uint16_t old_cmd =  9  + 1;
static uint8_t life_cnt =  4 ;


static uint16_t overall_score;
static uint8_t bricks_destroyed =  0 ;
static uint8_t score_multiplier =  1 ;






static void drv_writePixel( uint16_t x, uint16_t y, uint16_t color )
{
 matrixrgb_writePixel( x, y, color );

}

static void drv_paintObject( demo_object_t object, uint8_t width, uint8_t height )
{
 uint16_t y;
 uint16_t x;

 for( y = object.y; y < object.y + height; y++ )
 for( x = object.x; x < object.x + width; x++ )
 drv_writePixel( x, y, object.color );
}


static void drv_updateScore( )
{
 bricks_destroyed++;

 if( bricks_destroyed >=  30  )
 if( bricks_destroyed >=  38  )
 if( bricks_destroyed >=  44  )
 {
 switch ( bricks_destroyed )
 {
 case  45 :
 score_multiplier =  25 ;
 break;
 case  46 :
 score_multiplier =  50 ;
 break;
 case  47 :
 score_multiplier =  100 ;
 break;
 default:
 score_multiplier =  5 ;
 }
 }
 else
 score_multiplier =  4 ;
 else
 score_multiplier =  3 ;
 else
 score_multiplier =  2 ;

 overall_score +=  2  * score_multiplier;
}


static uint8_t drv_determineBrickCollision( demo_ball_t ball, demo_bounds_t bounds )
{
 if( ball.x == bounds.x_min )
 if( ball.y == bounds.y_min )
 return  23 ;
 else
 if( ball.y == bounds.y_max )
 return  21 ;
 else
 return  22 ;
 else if( ball.x == bounds.x_max )
 if( ball.y == bounds.y_min )
 return  17 ;
 else
 if( ball.y == bounds.y_max )
 return  19 ;
 else
 return  18 ;
 else
 if( ball.y == bounds.y_max )
 return  20 ;
 else
 return  16 ;
}

static uint8_t drv_redirectBall( uint8_t direction )
{
 switch( direction )
 {



 case  0 :
 return  ( rand( ) % ( 5  - 3  + 1 ) + 3  ) ;
 case  4 :
 return (  ( rand( ) % ( 2  - 0  + 1 ) + 0  )  + 7 ) % 8;

 case  8 :
 return  3 ;
 case  9 :
 return  5 ;
 case  10 :
 return  7 ;
 case  11 :
 return  5 ;
 case  12 :
 return  1 ;
 case  13 :
 return  7 ;
 case  14 :
 return  3 ;
 case  15 :
 return  1 ;




 case  16 :
 if( direction ==  3  )
 return  1 ;
 else
 return  7 ;
 case  18 :
 if( direction ==  7  )
 return  1 ;
 else
 return  3 ;
 case  20 :
 if( direction ==  1  )
 return  3 ;
 else
 return  5 ;
 case  22 :
 if( direction ==  3  )
 return  5 ;
 else
 return  7 ;

 case  17 :
 return  1 ;
 case  19 :
 return  3 ;
 case  21 :
 return  5 ;
 case  23 :
 return  7 ;
 }
}

static void drv_repositionBall( demo_ball_t *ball )
{
 switch( ball->direction )
 {
 case 0:
 ball->y -= 1;
 break;
 case 1:
 ball->x += 1;
 ball->y -= 1;
 break;
 case 2:
 ball->x += 1;
 break;
 case 3:
 ball->x += 1;
 ball->y += 1;
 break;
 case 4:
 ball->y += 1;
 break;
 case 5:
 ball->x -= 1;
 ball->y += 1;
 break;
 case 6:
 ball->x -= 1;
 break;
 case 7:
 ball->x -= 1;
 ball->y -= 1;
 }
}


static uint8_t drv_edgeCheck( demo_ball_t *ball )
{
 uint16_t topLeftLimit =  0  - 1;
 uint16_t botRightLimit =  31  + 1;

 if( ball->x == topLeftLimit )
 {
 if( ball->direction ==  5  )
 ball->direction = drv_redirectBall(  14  );
 else if( ball->direction ==  7  )
 ball->direction = drv_redirectBall(  15  );
 else
 ball->direction = drv_redirectBall( ball->direction );

 return  5 ;
 }
 if( ball->y == topLeftLimit )
 {
 if( ball->direction ==  1  )
 ball->direction = drv_redirectBall(  8  );
 else if( ball->direction ==  7  )
 ball->direction = drv_redirectBall(  9  );
 else
 ball->direction = drv_redirectBall( ball->direction );

 return  2 ;
 }
 if( ball->x == botRightLimit )
 {
 if( ball->direction ==  1  )
 ball->direction = drv_redirectBall(  10  );
 else if( ball->direction ==  3  )
 ball->direction = drv_redirectBall(  11  );
 else
 ball->direction = drv_redirectBall( ball->direction );

 return  3 ;
 }
 if( ball->y == botRightLimit )
 {
 return  4 ;
 }

 return  0 ;
}

static uint8_t drv_paddleCheck( demo_ball_t *ball, demo_object_t *paddle )
{
 if( paddle->y <= ball->y )
 if( paddle->y +  1  - 1 >= ball->y )
 if( paddle->x <= ball->x )
 if( paddle->x +  6  - 1 >= ball->x )
 {
 if( ball->direction ==  3  )
 ball->direction = drv_redirectBall(  12  );
 else if( ball->direction ==  5  )
 ball->direction = drv_redirectBall(  13  );
 else
 ball->direction = drv_redirectBall( ball->direction );

 return  6 ;
 }

 return  0 ;
}

static uint8_t drv_brickCheck( demo_ball_t *ball, demo_object_t *wall )
{
 demo_bounds_t bounds;

 uint8_t max =  8  * 6 ;
 uint8_t min = 0;
 uint8_t index = max / 2;
 uint8_t old_index = 0;

 while( min <= index && index <= max && index != old_index )
 {
 if( wall[ index ].y <= ball->y )
 if( ball->y <= wall[ index ].y +  2  - 1 )
 if( wall[ index ].x <= ball->x )
 if( ball->x <= wall[ index ].x +  4  - 1 )
 if( wall[ index ].color ==  0x0000  )
 return  0 ;
 else
 {
 bounds.x_min = wall[ index ].x;
 bounds.y_min = wall[ index ].y;
 bounds.x_max = wall[ index ].x +  4  - 1;
 bounds.y_max = wall[ index ].y +  2  - 1;

 ball->direction = drv_redirectBall( drv_determineBrickCollision(
 ( *ball ), bounds ) );
 wall[ index ].color =  0x0000 ;
 drv_paintObject( wall[ index ],  4 ,  2  );

 drv_updateScore( );

 return  1 ;
 }
 else
 min = index;
 else
 max = index;
 else
 min = index;
 else
 max = index;

 old_index = index;
 index = min + ( max - min ) / 2;
 }

 return  0 ;
}





void demo_generateWall( demo_object_t *wall )
{
 uint16_t x;
 uint16_t y;
 uint8_t cnt;
 uint16_t color;

 cnt = 0;
 color = 0x0000;

 for( y = 0; y <  6 ; y++ )
 {
 for( x = 0; x <  8 ; x++ )
 {
 switch( cnt % 3 )
 {
 case 1:
 color =  0xF800 ;
 break;
 case 2:
 color =  0x07E0 ;
 break;
 case 0:
 color =  0x001F ;
 }
 wall[ cnt ].x = x *  4 ;
 wall[ cnt ].y = y *  2 ;
 wall[ cnt++ ].color = color;

 drv_paintObject( wall[ cnt - 1 ],  4 ,  2  );
 }
 }

 overall_score = 0;
}

void demo_reset( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall )
{
 uint16_t cnt = 0;
 char temp_data[ 50 ];

 if( life_cnt == 1 )
 {
 matrixrgb_fillScreen(  0x0000  );

 while( cnt <  272  )
 {
 drv_writePixel( game_over[ cnt ], game_over[ cnt + 1 ],  0xF800  );
 cnt += 2;
 }

 mikrobus_logWrite( " * SCORE: ", _LOG_TEXT );
 IntToStr( overall_score, temp_data );
 Ltrim( temp_data );
 mikrobus_logWrite( temp_data, _LOG_LINE );

 bricks_destroyed =  0 ;

 Delay_ms(  3000  );
 }
 else if( life_cnt == 0 )
 {
 matrixrgb_fillScreen(  0x0000  );
 Delay_ms(  3000  / 2 );
 demo_generateWall( wall );

 life_cnt =  4 ;
 }

 life_cnt--;


 drv_writePixel( ball->x, ball->y,  0x0000  );

 ball->x =  0x0010 ;
 ball->y =  0x001C ;
 ball->direction =  0 ;
 drv_writePixel(  0x0010 ,  0x001C ,  0xFFFF  );


 paddle->color =  0x0000 ;
 drv_paintObject( ( *paddle ),  6 ,  1  );

 paddle->x =  0x000D ;
 paddle->y =  0x001F ;
 paddle->color =  0xF800 ;
 drv_paintObject( ( *paddle ),  6 ,  1  );
}




void demo_moveBall( demo_ball_t *ball )
{
 drv_writePixel( ball->x, ball->y,  0x0000  );
 drv_repositionBall( ball );
 drv_writePixel( ball->x, ball->y,  0xFFFF  );


 switch ( score_multiplier )
 {
 case  1 :
 Delay_ms(  50  );
 break;
 case  2 :
 Delay_ms(  40  );
 break;
 case  3 :
 Delay_ms(  30  );
 break;
 case  4 :
 Delay_ms(  20  );
 break;
 default:
 Delay_ms(  10  );
 }
}


void demo_movePaddle( demo_object_t *paddle, uint8_t mode )
{
 uint16_t cmd;

 if( mode ==  0  )
 {
 cmd = ADC1_Read( 3 );
 cmd >>= 8;

 if( cmd != old_cmd )
 {
 paddle->color =  0x0000 ;
 drv_paintObject( ( *paddle ),  6 ,  1  );

 if( ( cmd % 2 ) != 0 )
 paddle->x = ( cmd - 1 ) * 3;
 else
 paddle->x = ( cmd - 2 ) * 3 + 2;

 old_cmd = cmd;

 paddle->color =  0xF800 ;
 drv_paintObject( ( *paddle ),  6 ,  1  );
 }
 }
}


uint8_t demo_collisionCheck( demo_ball_t *ball, demo_object_t *paddle, demo_object_t *wall )
{
 uint16_t old_x;
 uint16_t old_y;
 uint8_t status;

 old_x = ball->x;
 old_y = ball->y;

 drv_repositionBall( ball );

 switch( ball->direction )
 {
 case  0 :
 if( !( status = drv_edgeCheck( ball ) ) )
 status = drv_brickCheck( ball, wall );
 break;
 case  1 :
 if( !( status = drv_edgeCheck( ball ) ) )
 status = drv_brickCheck( ball, wall );
 break;
 case  3 :
 if( !( status = drv_edgeCheck( ball ) ) )
 if( !( status = drv_paddleCheck( ball, paddle ) ) )
 status = drv_brickCheck( ball, wall );
 break;
 case  4 :
 if( !( status = drv_edgeCheck( ball ) ) )
 if( !( status = drv_paddleCheck( ball, paddle ) ) )
 status = drv_brickCheck( ball, wall );
 break;
 case  5 :
 if( !( status = drv_edgeCheck( ball ) ) )
 if( !( status = drv_paddleCheck( ball, paddle ) ) )
 status = drv_brickCheck( ball, wall );
 break;
 case  7 :
 if( !( status = drv_edgeCheck( ball ) ) )
 status = drv_brickCheck( ball, wall );
 }

 ball->x = old_x;
 ball->y = old_y;

 if( status ==  4  )
 demo_reset( ball, paddle, wall );

 return status;
}
